CREATE TABLE IF NOT EXISTS cs.command_store (

  command_store_id         UUID         NOT NULL,
  model_name               TEXT         NOT NULL,
  model_version_num        TEXT         NOT NULL,
  domain_root_aggregate_id TEXT         NOT NULL,
  integrity_fingerprint    TEXT         NOT NULL,
  payload_data             JSONB        NOT NULL,
  requestor_data           JSONB        NULL,
  audit_insert_date        TIMESTAMP(0) NOT NULL,
  CONSTRAINT pk_command_store PRIMARY KEY (command_store_id)
);

COMMENT ON TABLE cs.command_store IS 'The command store objects purpose is to support the processing of the commands that conforms to CQRS or CQS design principles';


COMMENT ON COLUMN cs.command_store.command_store_id IS 
'This is a UUID for the command being recorded in the database.
This id will be generated by the miroservice''s application layer, and ensures uniqueness of the command within the domain.' ;

COMMENT ON COLUMN cs.command_store.model_name IS 
'This is the name of the command that is stored. It will be simple string.
If we refer to the example, then it will store name as RegisterCustomerCommand.' ;

COMMENT ON COLUMN cs.command_store.model_version_num IS 
'This stores the version of the schema used. It will be simple string.
As the business evolves the business functions and processes will also evolve, and thus resulting in new version of the commands. Examples of version could be 1, 1.1, 2, etc.' ;

COMMENT ON COLUMN cs.command_store.domain_root_aggregate_id  IS 
'The Domain Root Aggregate Identifier ' ;

COMMENT ON COLUMN cs.command_store.integrity_fingerprint IS 
'This will be a SHA-256 hash of the command data being stored in the database. 
UUID need not be part of the hash, as the UUID itself does not add to business functionality. 
The command model name, command version, command requestor data and command payload data need to be member of the HASH.
This is to ensure protection of commands from tampering, and also validated integrity of the commands if replay is required.' ;

COMMENT ON COLUMN cs.command_store.payload_data IS 
'This is unstructured data, e.g. a JSON data, holding the domain data for the command.
This is a mandatory field. The domain processing will use this data to process the commands, and make changes to the domain aggregates.' ;

COMMENT ON COLUMN cs.command_store.requestor_data IS 
'This is unstructured data, e.g. a JSON data, holding the information about the requester.
This is a mandatory field where the domain requires awareness of the requester. 
Under a trusted model, where microservice only accepts communication from trusted channel, who are taking care of the origination security, this may not be neccessary.' ;

COMMENT ON COLUMN cs.command_store.audit_insert_date  IS 
'The Date and Time the row was inserted into the table. ' ;


